package windowsPackage;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.ResultSet;
import java.sql.SQLException;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import mainPackage.MainFrame;

public class Travel extends JPanel {

	private MainFrame mainFrame;
	private JTextField tfFrom;
	private JTextField tfTo;
	private JTextField tfDepartureYear;
	private JTextField tfDepartureMonth;
	private JTextField tfDepartureDay;
	private JTextField tfDepartureHour;
	private JTextField tfDepartureMin;
	private JTextField tfArrivalYear;
	private JTextField tfArrivalMonth;
	private JTextField tfArrivalDay;
	private JTextField tfArrivalHour;
	private JTextField tfArrivalMin;
	private JLabel chosenFlightID = new JLabel("");
	private Database db;

	// Til oprettelse af ny rejse
	public Travel(MainFrame mainFrame) throws SQLException {
		db = new Database();
		this.mainFrame = mainFrame;
		makeContent();

	}
	
	public Travel(Integer travelNr, Integer flightID, String from, String to,
			String departure, String arrival) throws SQLException {
		db = new Database();
		JPanel editTravelPanel = new JPanel(new BorderLayout());
		JPanel textFieldPanel = new JPanel (new GridLayout(0,2));
		JPanel buttonPanel = new JPanel();

		JLabel travelNrLabel = new JLabel("Rejse nr");
		JLabel flightNrLabel = new JLabel("Fly nr");
		JLabel fromLabel = new JLabel("Fra");
		JLabel toLabel = new JLabel("Til");

		final JTextField travelNrTF = new JTextField(travelNr.toString());
		tfFrom = new JTextField(from);
		tfTo = new JTextField(to);

		final JComboBox chooseFlightID = new JComboBox();
		String cmd = "SELECT AirPlaneID FROM `AirPlanes`";
		ResultSet rs = db.execute(cmd);
		try {
			while(rs.next()) {
				Integer flightIDFromDB = rs.getInt(1);
				chooseFlightID.addItem(flightIDFromDB);
				if(flightID == flightIDFromDB) {
					chooseFlightID.setSelectedItem(flightIDFromDB);
					chosenFlightID.setText(flightIDFromDB.toString());
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		//Gemmer det valgte fly i en variabel
		chooseFlightID.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Object selected = chooseFlightID.getSelectedItem();
				chosenFlightID.setText((String) selected.toString());
			}
		});

		JPanel flightPanel = new JPanel(new GridLayout(1,2));
		flightPanel.add(chooseFlightID);
		flightPanel.add(chosenFlightID);

		//RejseID m ikke ndres
		travelNrTF.setEditable(false);

		textFieldPanel.add(travelNrLabel);
		textFieldPanel.add(travelNrTF);
		textFieldPanel.add(flightNrLabel);
		textFieldPanel.add(flightPanel);
		textFieldPanel.add(fromLabel);
		textFieldPanel.add(tfFrom);
		textFieldPanel.add(toLabel);
		textFieldPanel.add(tfTo);

		//Dato felterne
		editTravelPanel.add(makeDatePanel(), BorderLayout.CENTER);
		String[] depStrings = departure.split("\\s");
		String[] depDateStrings = depStrings[0].split("\\.");
		String[] depTimeStrings = depStrings[1].split("\\:");
		tfDepartureYear.setText(depDateStrings[0]);
		tfDepartureMonth.setText(depDateStrings[1]);
		tfDepartureDay.setText(depDateStrings[2]);
		tfDepartureHour.setText(depTimeStrings[0]);
		tfDepartureMin.setText(depTimeStrings[1]);
		String[] arrStrings = arrival.split("\\s");
		String[] arrDateStrings = arrStrings[0].split("\\.");
		String[] arrTimeStrings = arrStrings[1].split("\\:");
		tfArrivalYear.setText(arrDateStrings[0]);
		tfArrivalMonth.setText(arrDateStrings[1]);
		tfArrivalDay.setText(arrDateStrings[2]);
		tfArrivalHour.setText(arrTimeStrings[0]);
		tfArrivalMin.setText(arrTimeStrings[1]);

		//Knapperne
		JButton editButton = new JButton("Opdater rejse");
		editButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(verifyInput() == "true") {
					try {
						//Danner afrejse stringen i det rigtige dato format s den passer i timestamp i databasen
						String departureDate = tfDepartureYear.getText() + "-" + tfDepartureMonth.getText() + "-"
								+ tfDepartureDay.getText() + " " + tfDepartureHour.getText() + ":" + tfDepartureMin.getText() + ":00";
						//Samme som ovenover, men med ankomst tidspunktet
						String arrivalDate = tfArrivalYear.getText() + "-" + tfArrivalMonth.getText() + "-" 
								+ tfArrivalDay.getText() + " " + tfArrivalHour.getText() + ":" + tfArrivalMin.getText() + ":00";

						//Opdaterer rejsen med de givne vrdier
						String cmd = "UPDATE Travel SET `AirPlaneID` = '"+chosenFlightID.getText()+"', `From` = '"
								+tfFrom.getText()+"', `To` = '"+tfTo.getText()+"', `Departure` = '"+departureDate+
								"', `Arrival` = '"+arrivalDate+"' WHERE `TravelID` = '"+travelNrTF.getText()+"'";
						db.insert(cmd);
						JOptionPane.showMessageDialog(null, "Rejsen er opdateret!");
						//Sender brugeren tilbage til hovedmenuen
						MainFrame.removeContent();
					}
					catch(SQLException e2) {
						JOptionPane.showMessageDialog(null, "Der skete en fejl! \n Fejlkode: " + e);
					}
				}
			}
		});
		JButton deleteButton = new JButton("Slet rejse");
		deleteButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					String cmd = "DELETE FROM Travel WHERE `TravelID` = '"+travelNrTF.getText()+"'";
					db.insert(cmd);
					cmd = "DELETE FROM Seats WHERE `TravelID` = '"+travelNrTF.getText()+"'";
					db.insert(cmd);
					cmd = "DELETE FROM Booking WHERE `TravelID` = '"+travelNrTF.getText()+"'";
					db.insert(cmd);
					JOptionPane.showMessageDialog(null, "Rejsen er slettet!");
					MainFrame.removeContent();
				}
				catch(SQLException e1) {
					JOptionPane.showMessageDialog(null, "Det var ikke muligt at slette rejsen! \n Fejlkode: " + e1);
				}
			}
		});

		buttonPanel.add(editButton);
		buttonPanel.add(deleteButton);
		editTravelPanel.add(textFieldPanel, BorderLayout.NORTH);
		editTravelPanel.add(buttonPanel, BorderLayout.SOUTH);
		add(editTravelPanel);
	}

	private JPanel makeDatePanel() {
		//Datoer
		JPanel departurePanel = new JPanel();
		departurePanel.setLayout(new FlowLayout());

		JLabel labelDeparture = new JLabel("Afrejse (YYYY-MM-DD HH:MM)", JLabel.CENTER);
		JLabel month = new JLabel("-");
		JLabel day = new JLabel("-");
		JLabel space = new JLabel(" : ");

		tfDepartureYear = new JTextField();
		tfDepartureMonth = new JTextField();
		tfDepartureDay = new JTextField();
		tfDepartureHour = new JTextField();
		tfDepartureMin = new JTextField();

		departurePanel.add(tfDepartureYear);
		departurePanel.add(month);
		departurePanel.add(tfDepartureMonth);
		departurePanel.add(day);
		departurePanel.add(tfDepartureDay);
		departurePanel.add(tfDepartureHour);
		departurePanel.add(space);
		departurePanel.add(tfDepartureMin);

		Dimension tfDimension = new Dimension(50, 20);
		tfDepartureYear.setPreferredSize(tfDimension);
		tfDepartureMonth.setPreferredSize(tfDimension);
		tfDepartureDay.setPreferredSize(tfDimension);
		tfDepartureHour.setPreferredSize(tfDimension);
		tfDepartureMin.setPreferredSize(tfDimension);

		JPanel arrivalPanel = new JPanel();
		arrivalPanel.setLayout(new FlowLayout());
		JLabel labelArrival = new JLabel("Ankomst (YYYY-MM-DD HH:MM)", JLabel.CENTER);
		tfArrivalYear = new JTextField();
		tfArrivalMonth = new JTextField();
		tfArrivalDay = new JTextField();
		tfArrivalHour = new JTextField();
		tfArrivalMin = new JTextField();

		// Definerer labelsne igen, ellers kan de ikke genbruges
		month = new JLabel("-");
		day = new JLabel("-");
		space = new JLabel(" : ");

		arrivalPanel.add(tfArrivalYear);
		arrivalPanel.add(month);
		arrivalPanel.add(tfArrivalMonth);
		arrivalPanel.add(day);
		arrivalPanel.add(tfArrivalDay);
		arrivalPanel.add(tfArrivalHour);
		arrivalPanel.add(space);
		arrivalPanel.add(tfArrivalMin);

		tfArrivalYear.setPreferredSize(tfDimension);
		tfArrivalMonth.setPreferredSize(tfDimension);
		tfArrivalDay.setPreferredSize(tfDimension);
		tfArrivalHour.setPreferredSize(tfDimension);
		tfArrivalMin.setPreferredSize(tfDimension);

		JPanel datePanel = new JPanel(new GridLayout(4,1));
		datePanel.add(labelDeparture);
		datePanel.add(departurePanel);
		datePanel.add(labelArrival);
		datePanel.add(arrivalPanel);
		return datePanel;
	}

	private void makeContent() {

		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		setBorder(BorderFactory.createTitledBorder(" Ny rejse "));

		JPanel subPanel = new JPanel();

		subPanel.setLayout(new FlowLayout());

		//Giver lidt afstand og rykker det hele mod venstre; 
		subPanel.setBorder(BorderFactory.createEmptyBorder(20, -200, 0, 0));

		// Deler det op i 2 panels, den venstre indeholder labels, hjre indeholder textFields. De der delt op i 2, for at kunne justere afstanden vertikalt og horisontalt individuelt
		JPanel leftPanel = new JPanel();
		JPanel rightPanel = new JPanel();

		// GridLayout gl = new GridLayout((labels.size()+1), 1);

		leftPanel.setLayout(new BoxLayout(leftPanel, BoxLayout.Y_AXIS));
		rightPanel.setLayout(new BoxLayout(rightPanel, BoxLayout.Y_AXIS));

		//Lav dropdown til valg af flyID
		try {
			final JComboBox chooseFlightID = new JComboBox();
			String cmd = "SELECT AirPlaneID FROM `AirPlanes`";
			ResultSet rs = db.execute(cmd);
			while(rs.next()) {
				int i = rs.getInt(1);
				chooseFlightID.addItem(i);
			}
			chooseFlightID.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					Object selected = chooseFlightID.getSelectedItem();
					chosenFlightID.setText((String) selected.toString());
				}
			});
			chooseFlightID.setSelectedIndex(0);
			JPanel flightPanel = new JPanel(new GridLayout(1,2));
			flightPanel.add(chooseFlightID);
			flightPanel.add(chosenFlightID);


			rightPanel.add(Box.createVerticalStrut(0));
			JLabel labelFlightID= new JLabel("Fly nr");
			leftPanel.add(labelFlightID);
			rightPanel.add(flightPanel);
			rightPanel.add(Box.createVerticalStrut(10));
			leftPanel.add(Box.createVerticalStrut(10));
			JLabel labelFrom = new JLabel("Fra");
			tfFrom = new JTextField();
			tfFrom.setMaximumSize(new Dimension(100, 20));

			leftPanel.add(labelFrom);
			rightPanel.add(tfFrom);
			rightPanel.add(Box.createVerticalStrut(10));
			leftPanel.add(Box.createVerticalStrut(15));
			leftPanel.add(Box.createRigidArea(new Dimension(100, 0)));

			JLabel labelTo = new JLabel("Til");
			tfTo = new JTextField();
			tfTo.setMaximumSize(new Dimension(100, 20));
			leftPanel.add(labelTo);
			rightPanel.add(tfTo);

			JPanel buttonPanel = new JPanel();
			buttonPanel.setLayout(new FlowLayout());

			JButton createTravel = new JButton("Opret Rejse");

			createTravel.addActionListener(new createTravelActionListener());

			buttonPanel.add(createTravel);
			subPanel.add(leftPanel);
			subPanel.add(rightPanel);

			add(subPanel);
			add(makeDatePanel());
			add(buttonPanel);
		}
		
		catch(SQLException | NullPointerException e) {
			JOptionPane.showMessageDialog(null, "Der skete en fejl! \n Fejlkode: " + e);
			MainFrame.removeContent();
		}

	}
	// Kontrollerer, at de indtastede vrdier, har et korrekt format og lngde
	public String verifyInput() {

		if(tfDepartureYear.getText().equals("") || tfDepartureMonth.getText().equals("") || tfDepartureDay.getText().equals("") 
				|| tfDepartureHour.getText().equals("") || tfDepartureMin.getText().equals("") || tfArrivalYear.getText().equals("") 
				|| tfArrivalMonth.getText().equals("") || tfArrivalDay.getText().equals("") || tfArrivalHour.getText().equals("") 
				|| tfArrivalMin.getText().equals("") || chosenFlightID.getText().equals("") || tfFrom.getText().equals("") 
				|| tfTo.getText().equals("")) {
			return "Alle felter skal udfyldes";
		}

		//Benytter regular expression til at kontrollere, at nogle felter kun indeholder tal og ikke bogstaver  Kilde: http://stackoverflow.com/questions/7512999/how-to-check-jtextfield-text-to-string
		String letters = "^[a-zA-Z]+$";
		if((tfDepartureYear.getText().matches(letters) || tfDepartureMonth.getText().matches(letters) || 
				tfDepartureDay.getText().matches(letters) || tfDepartureHour.getText().matches(letters) ||
				tfDepartureMin.getText().matches(letters) || tfArrivalYear.getText().matches(letters) ||
				tfArrivalMonth.getText().matches(letters) || tfArrivalDay.getText().matches(letters) || 
				tfArrivalHour.getText().matches(letters) || tfArrivalMin.getText().matches(letters)  || 
				chosenFlightID.getText().matches(letters))) {
			return "Forkert dato format. Datoen skal skrives i formatet yyyy-mm-dd hh:mm";
		}
		if(tfDepartureYear.getText().length() != 4 || tfDepartureMonth.getText().length() != 2 || tfDepartureDay.getText().length() != 2 ||
				tfDepartureHour.getText().length() != 2 || tfDepartureMin.getText().length() != 2 || tfArrivalYear.getText().length() != 4  ||
				tfArrivalMonth.getText().length() != 2 || tfArrivalDay.getText().length() != 2 || tfArrivalHour.getText().length() != 2 ||
				tfArrivalMin.getText().length() != 2) {
			return "Forkert dato format. Datoen skal skrives i formatet yyyy-mm-dd hh:mm";
		}

		if(tfFrom.getText().length() > 100 || tfTo.getText().length() > 100) {
			return "Felterne 'Fra' og 'Til' m ikke vre lngere end 100 karakterer";
		}
		return "true";
	}

	public void insertTravel() {
		try {
			if(verifyInput() == "true") {

				int numberOfRows = 0;
				int numberOfColumns = 0;
				int numberOfFreeSeats = 0;

				// Opret rejsen i databasen
				//Danner afrejse stringen i det rigtige dato format s den passer i timestamp i databasen
				String departureDate = tfDepartureYear.getText() + "-" + tfDepartureMonth.getText() + "-" + tfDepartureDay.getText() + " " + tfDepartureHour.getText() + ":" + tfDepartureMin.getText() + ":00";
				//Samme som ovenfor, blot med ankonsttiden
				String arrivalDate = tfArrivalYear.getText() + "-" + tfArrivalMonth.getText() + "-" + tfArrivalDay.getText() + " " + tfArrivalHour.getText() + ":" + tfArrivalMin.getText() + ":00";
				String cmd = "INSERT INTO `Travel` (`AirPlaneID`, `From`, `To`, `Departure`, `Arrival`, `FreeSeats`) VALUES('" + chosenFlightID.getText() + "', '" + tfFrom.getText() + "', '" + tfTo.getText() + "', '" + departureDate + "', '" + arrivalDate + "', '" + numberOfFreeSeats + "')";
				int travelID = 0;
				travelID = db.insertReturnKey(cmd);
				// Henter flytypen for det pgldende fly, flytypens antal rkker og antal kolonner 
				cmd = "Select `AirPlaneTypeID` FROM `AirPlanes` WHERE AirPlaneID = '" + chosenFlightID.getText() + "'";

				ResultSet rs = db.execute(cmd);
				int flightType = 0;
				
				rs.next();
				flightType = rs.getInt("AirPlaneTypeID");

				cmd = "Select * FROM `AirPlaneTypes` WHERE AirPlaneTypeID = '" + flightType + "'";
				rs = db.execute(cmd);
				rs.next();
				numberOfRows = rs.getInt("numberOfRows");
				numberOfColumns = rs.getInt("numberOfColumns");
				numberOfFreeSeats = numberOfRows*numberOfColumns;

				//Indster en rkke, for hvert sde i flyet
				for(int a = 1; a <= numberOfColumns; a++) { 
					for(int b = 1; b <= numberOfRows; b++) {
						cmd = "INSERT INTO `Seats` (`CustomerID`, `Row`, `Column`, `Booked`, `Status`, `TravelID`) VALUES('0', '" + b + "', '" + a + "', '0', 'Ikke checket ind', '" + travelID + "')";
						db.insert(cmd);
					}
				}

				// Opdaterer den oprettede rejse, nu med antallet af ledige sder, som lige er kalkuleret
				cmd = "UPDATE Travel SET FreeSeats ='"+numberOfFreeSeats+"' WHERE TravelID = '" + travelID + "'";
				db.insert(cmd);

				JOptionPane.showMessageDialog(null, "Rejsen er oprettet");
				MainFrame.removeContent();
			}
			else {
				JOptionPane.showMessageDialog(null, verifyInput());
			}
		}
		catch (SQLException e1) {
			e1.printStackTrace();
			JOptionPane.showMessageDialog(null, "Der skete en fejl under oprettelsen af rejsen. \n Fejlkode: " + e1);
		}
	}

	//Setters til JUnit test
	public void setFlightID(String text) {
		chosenFlightID.setText(text);
	}
	public void setFrom(String text) {
		tfFrom.setText(text);
	}
	public void setTo(String text) {
		tfTo.setText(text);
	}
	public void setDepYear(String text) {
		tfDepartureYear.setText(text);
	}
	public void setDepMonth(String text) {
		tfDepartureMonth.setText(text);
	}
	public void setDepDay(String text) {
		tfDepartureDay.setText(text);
	}
	public void setDepHour(String text) {
		tfDepartureHour.setText(text);
	}
	public void setDepMin(String text) {
		tfDepartureMin.setText(text);
	}
	public void setArrYear(String text) {
		tfArrivalYear.setText(text);
	}
	public void setArrMonth(String text) {
		tfArrivalMonth.setText(text);
	}
	public void setArrDay(String text) {
		tfArrivalDay.setText(text);
	}
	public void setArrHour(String text) {
		tfArrivalHour.setText(text);
	}
	public void setArrMin(String text) {
		tfArrivalMin.setText(text);
	}

	class createTravelActionListener implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			insertTravel();
		}
	}
}
